DirectoryScanner (Apache Ant API)
Date: 2018-03-24

org.apache.tools.ant

## Class DirectoryScanner

- java.lang.Object
- - org.apache.tools.ant.DirectoryScanner

- All Implemented Interfaces:
    FileScanner, ResourceFactory, SelectorScanner
  Direct Known Subclasses:
    ArchiveScanner, DependScanner, FTP.FTPDirectoryScanner, FTPTaskMirrorImpl.FTPDirectoryScanner

      public class DirectoryScanner
      extends java.lang.Object
      implements FileScanner, SelectorScanner, ResourceFactory

  Class for scanning a directory for files/directories which match certain criteria.

  These criteria consist of selectors and patterns which have been specified. With the selectors you can select which files you want to have included. Files which are not selected are excluded. With patterns you can include or exclude files based on their filename.

  The idea is simple. A given directory is recursively scanned for all files and directories. Each file/directory is matched against a set of selectors, including special support for matching against filenames with include and and exclude patterns. Only files/directories which match at least one pattern of the include pattern list or other file selector, and don't match any pattern of the exclude pattern list or fail to match against a required selector will be placed in the list of files/directories found.

  When no list of include patterns is supplied, "**" will be used, which means that everything will be matched. When no list of exclude patterns is supplied, an empty list is used, such that nothing will be excluded. When no selectors are supplied, none are applied.

  The filename pattern matching is done as follows: The name to be matched is split up in path segments. A path segment is the name of a directory or file, which is bounded by `File.separator` ('/' under UNIX, '\' under Windows). For example, "abc/def/ghi/xyz.java" is split up in the segments "abc", "def","ghi" and "xyz.java". The same is done for the pattern against which should be matched.

  The segments of the name and the pattern are then matched against each other. When '**' is used for a path segment in the pattern, it matches zero or more path segments of the name.

  There is a special case regarding the use of `File.separator`s at the beginning of the pattern and the string to match:

  - When a pattern starts with a `File.separator`, the string to match must also start with a `File.separator`.
  - When a pattern does not start with a `File.separator`, the string to match may not start with a `File.separator`.
  - When one of the above rules is not obeyed, the string will not match.

  When a name path segment is matched against a pattern path segment, the following special characters can be used:
  '*' matches zero or more characters
  '?' matches one character.

  Examples:

  "**\*.class" matches all .class files/dirs in a directory tree.

  "test\a??.java" matches all files/dirs which start with an 'a', then two more characters and then ".java", in a directory called test.

  "**" matches everything in a directory tree.

  "**\test\**\XYZ*" matches all files/dirs which start with "XYZ" and where there is a parent directory called test (e.g. "abc\test\def\ghi\XYZ123").

  Case sensitivity may be turned off if necessary. By default, it is turned on.

  Example of usage:

         String[] includes = {"*\*\*.class"};
         String[] excludes = {"modules\\\*\**"};
         ds.setIncludes(includes);
         ds.setExcludes(excludes);
         ds.setBasedir(new File("test"));
         ds.setCaseSensitive(true);
         ds.scan();

         System.out.println("FILES:");
         String[] files = ds.getIncludedFiles();
         for (int i = 0; i < files.length; i++) {
           System.out.println(files[i]);
         }

  This will scan a directory called test for .class files, but excludes all files in all proper subdirectories of a directory called "modules".

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.io.File` | `basedir` The base directory to be scanned.
    `protected static java.lang.String[]` | `DEFAULTEXCLUDES` Deprecated. since 1.6.x. Use the `getDefaultExcludes` method instead.
    `protected java.util.Vector<java.lang.String>` | `dirsDeselected` The directories which matched at least one include and no excludes but which a selector discarded.
    `protected java.util.Vector<java.lang.String>` | `dirsExcluded` The directories which matched at least one include and at least one exclude.
    `protected java.util.Vector<java.lang.String>` | `dirsIncluded` The directories which matched at least one include and no excludes and were selected.
    `protected java.util.Vector<java.lang.String>` | `dirsNotIncluded` The directories which were found and did not match any includes.
    `static java.lang.String` | `DOES_NOT_EXIST_POSTFIX` The end of the exception message if something that should be there doesn't exist.
    `protected boolean` | `errorOnMissingDir` Whether a missing base directory is an error.
    `protected boolean` | `everythingIncluded` Whether or not everything tested so far has been included.
    `protected java.lang.String[]` | `excludes` The patterns for the files to be excluded.
    `protected java.util.Vector<java.lang.String>` | `filesDeselected` The files which matched at least one include and no excludes and which a selector discarded.
    `protected java.util.Vector<java.lang.String>` | `filesExcluded` The files which matched at least one include and at least one exclude.
    `protected java.util.Vector<java.lang.String>` | `filesIncluded` The files which matched at least one include and no excludes and were selected.
    `protected java.util.Vector<java.lang.String>` | `filesNotIncluded` The files which did not match any includes or selectors.
    `protected boolean` | `haveSlowResults` Whether or not our results were built by a slow scan.
    `protected java.lang.String[]` | `includes` The patterns for the files to be included.
    `protected boolean` | `isCaseSensitive` Whether or not the file system should be treated as a case sensitive one.
    `static int` | `MAX_LEVELS_OF_SYMLINKS` default value for `maxLevelsOfSymlinks`
    `protected FileSelector[]` | `selectors` Selectors that will filter which files are in our candidate list.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DirectoryScanner()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `addDefaultExclude(java.lang.String s)` Add a pattern to the default excludes unless it is already a default exclude.
    `void` | `addDefaultExcludes()` Add default exclusions to the current exclusions set.
    `void` | `addExcludes(java.lang.String[] excludes)` Add to the list of exclude patterns to use.
    `protected void` | `clearResults()` Clear the result caches for a scan.
    `protected boolean` | `couldHoldIncluded(java.lang.String name)` Test whether or not a name matches the start of at least one include pattern.
    `java.io.File` | `getBasedir()` Return the base directory to be scanned.
    `static java.lang.String[]` | `getDefaultExcludes()` Get the list of patterns that should be excluded by default.
    `java.lang.String[]` | `getDeselectedDirectories()` Return the names of the directories which were selected out and therefore not ultimately included.
    `java.lang.String[]` | `getDeselectedFiles()` Return the names of the files which were selected out and therefore not ultimately included.
    `java.lang.String[]` | `getExcludedDirectories()` Return the names of the directories which matched at least one of the include patterns and at least one of the exclude patterns.
    `java.lang.String[]` | `getExcludedFiles()` Return the names of the files which matched at least one of the include patterns and at least one of the exclude patterns.
    `java.lang.String[]` | `getIncludedDirectories()` Return the names of the directories which matched at least one of the include patterns and none of the exclude patterns.
    `int` | `getIncludedDirsCount()` Return the count of included directories.
    `java.lang.String[]` | `getIncludedFiles()` Return the names of the files which matched at least one of the include patterns and none of the exclude patterns.
    `int` | `getIncludedFilesCount()` Return the count of included files.
    `java.lang.String[]` | `getNotFollowedSymlinks()` Absolute paths of all symbolic links that haven't been followed but would have been followed had followsymlinks been true or maxLevelsOfSymlinks been bigger.
    `java.lang.String[]` | `getNotIncludedDirectories()` Return the names of the directories which matched none of the include patterns.
    `java.lang.String[]` | `getNotIncludedFiles()` Return the names of the files which matched none of the include patterns.
    `Resource` | `getResource(java.lang.String name)` Get the named resource.
    `boolean` | `isCaseSensitive()` Find out whether include exclude patterns are matched in a case sensitive way.
    `boolean` | `isEverythingIncluded()` Return whether or not the scanner has included all the files or directories it has come across so far.
    `protected boolean` | `isExcluded(java.lang.String name)` Test whether or not a name matches against at least one exclude pattern.
    `boolean` | `isFollowSymlinks()` Get whether or not a DirectoryScanner follows symbolic links.
    `protected boolean` | `isIncluded(java.lang.String name)` Test whether or not a name matches against at least one include pattern.
    `protected boolean` | `isSelected(java.lang.String name, java.io.File file)` Test whether a file should be selected.
    `static boolean` | `match(java.lang.String pattern, java.lang.String str)` Test whether or not a string matches against a pattern.
    `protected static boolean` | `match(java.lang.String pattern, java.lang.String str, boolean isCaseSensitive)` Test whether or not a string matches against a pattern.
    `protected static boolean` | `matchPath(java.lang.String pattern, java.lang.String str)` Test whether or not a given path matches a given pattern.
    `protected static boolean` | `matchPath(java.lang.String pattern, java.lang.String str, boolean isCaseSensitive)` Test whether or not a given path matches a given pattern.
    `protected static boolean` | `matchPatternStart(java.lang.String pattern, java.lang.String str)` Test whether or not a given path matches the start of a given pattern up to the first "**".
    `protected static boolean` | `matchPatternStart(java.lang.String pattern, java.lang.String str, boolean isCaseSensitive)` Test whether or not a given path matches the start of a given pattern up to the first "**".
    `static boolean` | `removeDefaultExclude(java.lang.String s)` Remove a string if it is a default exclude.
    `static void` | `resetDefaultExcludes()` Go back to the hardwired default exclude patterns.
    `void` | `scan()` Scan for files which match at least one include pattern and don't match any exclude patterns.
    `protected void` | `scandir(java.io.File dir, java.lang.String vpath, boolean fast)` Scan the given directory for files and directories.
    `void` | `setBasedir(java.io.File basedir)` Set the base directory to be scanned.
    `void` | `setBasedir(java.lang.String basedir)` Set the base directory to be scanned.
    `void` | `setCaseSensitive(boolean isCaseSensitive)` Set whether or not include and exclude patterns are matched in a case sensitive way.
    `void` | `setErrorOnMissingDir(boolean errorOnMissingDir)` Sets whether or not a missing base directory is an error
    `void` | `setExcludes(java.lang.String[] excludes)` Set the list of exclude patterns to use.
    `void` | `setFollowSymlinks(boolean followSymlinks)` Set whether or not symbolic links should be followed.
    `void` | `setIncludes(java.lang.String[] includes)` Set the list of include patterns to use.
    `void` | `setMaxLevelsOfSymlinks(int max)` The maximum number of times a symbolic link may be followed during a scan.
    `void` | `setSelectors(FileSelector[] selectors)` Set the selectors that will select the filelist.
    `protected void` | `slowScan()` Top level invocation for a slow scan.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULTEXCLUDES

          @Deprecated
          protected static final java.lang.String[] DEFAULTEXCLUDES

      Deprecated. since 1.6.x. Use the `getDefaultExcludes` method instead.
      Patterns which should be excluded by default.

      Note that you can now add patterns to the list of default excludes. Added patterns will not become part of this array that has only been kept around for backwards compatibility reasons.

    - #### MAX_LEVELS_OF_SYMLINKS

          public static final int MAX_LEVELS_OF_SYMLINKS

      default value for `maxLevelsOfSymlinks`
      Since:
        Ant 1.8.0
      See Also:
        Constant Field Values

    - #### DOES_NOT_EXIST_POSTFIX

          public static final java.lang.String DOES_NOT_EXIST_POSTFIX

      The end of the exception message if something that should be there doesn't exist.
      See Also:
        Constant Field Values

    - #### basedir

          protected java.io.File basedir

      The base directory to be scanned.

    - #### includes

          protected java.lang.String[] includes

      The patterns for the files to be included.

    - #### excludes

          protected java.lang.String[] excludes

      The patterns for the files to be excluded.

    - #### selectors

          protected FileSelector[] selectors

      Selectors that will filter which files are in our candidate list.

    - #### filesIncluded

          protected java.util.Vector<java.lang.String> filesIncluded

      The files which matched at least one include and no excludes and were selected.

    - #### filesNotIncluded

          protected java.util.Vector<java.lang.String> filesNotIncluded

      The files which did not match any includes or selectors.

    - #### filesExcluded

          protected java.util.Vector<java.lang.String> filesExcluded

      The files which matched at least one include and at least one exclude.

    - #### dirsIncluded

          protected java.util.Vector<java.lang.String> dirsIncluded

      The directories which matched at least one include and no excludes and were selected.

    - #### dirsNotIncluded

          protected java.util.Vector<java.lang.String> dirsNotIncluded

      The directories which were found and did not match any includes.

    - #### dirsExcluded

          protected java.util.Vector<java.lang.String> dirsExcluded

      The directories which matched at least one include and at least one exclude.

    - #### filesDeselected

          protected java.util.Vector<java.lang.String> filesDeselected

      The files which matched at least one include and no excludes and which a selector discarded.

    - #### dirsDeselected

          protected java.util.Vector<java.lang.String> dirsDeselected

      The directories which matched at least one include and no excludes but which a selector discarded.

    - #### haveSlowResults

          protected boolean haveSlowResults

      Whether or not our results were built by a slow scan.

    - #### isCaseSensitive

          protected boolean isCaseSensitive

      Whether or not the file system should be treated as a case sensitive one.

    - #### errorOnMissingDir

          protected boolean errorOnMissingDir

      Whether a missing base directory is an error.
      Since:
        Ant 1.7.1

    - #### everythingIncluded

          protected boolean everythingIncluded

      Whether or not everything tested so far has been included.

  - ### Constructor Detail

    - #### DirectoryScanner

          public DirectoryScanner()

  - ### Method Detail

    - #### matchPatternStart

          protected static boolean matchPatternStart(java.lang.String pattern,
                                                     java.lang.String str)

      Test whether or not a given path matches the start of a given pattern up to the first "**".

      This is not a general purpose test and should only be used if you can live with false positives. For example, `pattern=**\a` and `str=b` will yield `true`.

      Parameters:
        `pattern` - The pattern to match against. Must not be `null`.
        `str` - The path to match, as a String. Must not be `null`.
      Returns:
        whether or not a given path matches the start of a given pattern up to the first "**".

    - #### matchPatternStart

          protected static boolean matchPatternStart(java.lang.String pattern,
                                                     java.lang.String str,
                                                     boolean isCaseSensitive)

      Test whether or not a given path matches the start of a given pattern up to the first "**".

      This is not a general purpose test and should only be used if you can live with false positives. For example, `pattern=**\a` and `str=b` will yield `true`.

      Parameters:
        `pattern` - The pattern to match against. Must not be `null`.
        `str` - The path to match, as a String. Must not be `null`.
        `isCaseSensitive` - Whether or not matching should be performed case sensitively.
      Returns:
        whether or not a given path matches the start of a given pattern up to the first "**".

    - #### matchPath

          protected static boolean matchPath(java.lang.String pattern,
                                             java.lang.String str)

      Test whether or not a given path matches a given pattern.
      Parameters:
        `pattern` - The pattern to match against. Must not be `null`.
        `str` - The path to match, as a String. Must not be `null`.
      Returns:
        `true` if the pattern matches against the string, or `false` otherwise.

    - #### matchPath

          protected static boolean matchPath(java.lang.String pattern,
                                             java.lang.String str,
                                             boolean isCaseSensitive)

      Test whether or not a given path matches a given pattern.
      Parameters:
        `pattern` - The pattern to match against. Must not be `null`.
        `str` - The path to match, as a String. Must not be `null`.
        `isCaseSensitive` - Whether or not matching should be performed case sensitively.
      Returns:
        `true` if the pattern matches against the string, or `false` otherwise.

    - #### match

          public static boolean match(java.lang.String pattern,
                                      java.lang.String str)

      Test whether or not a string matches against a pattern. The pattern may contain two special characters:
      '*' means zero or more characters
      '?' means one and only one character
      Parameters:
        `pattern` - The pattern to match against. Must not be `null`.
        `str` - The string which must be matched against the pattern. Must not be `null`.
      Returns:
        `true` if the string matches against the pattern, or `false` otherwise.

    - #### match

          protected static boolean match(java.lang.String pattern,
                                         java.lang.String str,
                                         boolean isCaseSensitive)

      Test whether or not a string matches against a pattern. The pattern may contain two special characters:
      '*' means zero or more characters
      '?' means one and only one character
      Parameters:
        `pattern` - The pattern to match against. Must not be `null`.
        `str` - The string which must be matched against the pattern. Must not be `null`.
        `isCaseSensitive` - Whether or not matching should be performed case sensitively.
      Returns:
        `true` if the string matches against the pattern, or `false` otherwise.

    - #### getDefaultExcludes

          public static java.lang.String[] getDefaultExcludes()

      Get the list of patterns that should be excluded by default.
      Returns:
        An array of `String` based on the current contents of the `defaultExcludes` `Set`.
      Since:
        Ant 1.6

    - #### addDefaultExclude

          public static boolean addDefaultExclude(java.lang.String s)

      Add a pattern to the default excludes unless it is already a default exclude.
      Parameters:
        `s` - A string to add as an exclude pattern.
      Returns:
        `true` if the string was added; `false` if it already existed.
      Since:
        Ant 1.6

    - #### removeDefaultExclude

          public static boolean removeDefaultExclude(java.lang.String s)

      Remove a string if it is a default exclude.
      Parameters:
        `s` - The string to attempt to remove.
      Returns:
        `true` if `s` was a default exclude (and thus was removed); `false` if `s` was not in the default excludes list to begin with.
      Since:
        Ant 1.6

    - #### resetDefaultExcludes

          public static void resetDefaultExcludes()

      Go back to the hardwired default exclude patterns.
      Since:
        Ant 1.6

    - #### setBasedir

          public void setBasedir(java.lang.String basedir)

      Set the base directory to be scanned. This is the directory which is scanned recursively. All '/' and '\' characters are replaced by `File.separatorChar`, so the separator used need not match `File.separatorChar`.
      Specified by:
        `setBasedir` in interface `FileScanner`
      Parameters:
        `basedir` - The base directory to scan.

    - #### setBasedir

          public void setBasedir(java.io.File basedir)

      Set the base directory to be scanned. This is the directory which is scanned recursively.
      Specified by:
        `setBasedir` in interface `FileScanner`
      Parameters:
        `basedir` - The base directory for scanning.

    - #### getBasedir

          public java.io.File getBasedir()

      Return the base directory to be scanned. This is the directory which is scanned recursively.
      Specified by:
        `getBasedir` in interface `FileScanner`
      Returns:
        the base directory to be scanned.

    - #### isCaseSensitive

          public boolean isCaseSensitive()

      Find out whether include exclude patterns are matched in a case sensitive way.
      Returns:
        whether or not the scanning is case sensitive.
      Since:
        Ant 1.6

    - #### setCaseSensitive

          public void setCaseSensitive(boolean isCaseSensitive)

      Set whether or not include and exclude patterns are matched in a case sensitive way.
      Specified by:
        `setCaseSensitive` in interface `FileScanner`
      Parameters:
        `isCaseSensitive` - whether or not the file system should be regarded as a case sensitive one.

    - #### setErrorOnMissingDir

          public void setErrorOnMissingDir(boolean errorOnMissingDir)

      Sets whether or not a missing base directory is an error
      Parameters:
        `errorOnMissingDir` - whether or not a missing base directory is an error
      Since:
        Ant 1.7.1

    - #### isFollowSymlinks

          public boolean isFollowSymlinks()

      Get whether or not a DirectoryScanner follows symbolic links.
      Returns:
        flag indicating whether symbolic links should be followed.
      Since:
        Ant 1.6

    - #### setFollowSymlinks

          public void setFollowSymlinks(boolean followSymlinks)

      Set whether or not symbolic links should be followed.
      Parameters:
        `followSymlinks` - whether or not symbolic links should be followed.

    - #### setMaxLevelsOfSymlinks

          public void setMaxLevelsOfSymlinks(int max)

      The maximum number of times a symbolic link may be followed during a scan.
      Parameters:
        `max` - int
      Since:
        Ant 1.8.0

    - #### setIncludes

          public void setIncludes(java.lang.String[] includes)

      Set the list of include patterns to use. All '/' and '\' characters are replaced by `File.separatorChar`, so the separator used need not match `File.separatorChar`.

      When a pattern ends with a '/' or '\', "**" is appended.

      Specified by:
        `setIncludes` in interface `FileScanner`
      Parameters:
        `includes` - A list of include patterns. May be `null`, indicating that all files should be included. If a non-`null` list is given, all elements must be non-`null`.

    - #### setExcludes

          public void setExcludes(java.lang.String[] excludes)

      Set the list of exclude patterns to use. All '/' and '\' characters are replaced by `File.separatorChar`, so the separator used need not match `File.separatorChar`.

      When a pattern ends with a '/' or '\', "**" is appended.

      Specified by:
        `setExcludes` in interface `FileScanner`
      Parameters:
        `excludes` - A list of exclude patterns. May be `null`, indicating that no files should be excluded. If a non-`null` list is given, all elements must be non-`null`.

    - #### addExcludes

          public void addExcludes(java.lang.String[] excludes)

      Add to the list of exclude patterns to use. All '/' and '\' characters are replaced by `File.separatorChar`, so the separator used need not match `File.separatorChar`.

      When a pattern ends with a '/' or '\', "**" is appended.

      Parameters:
        `excludes` - A list of exclude patterns. May be `null`, in which case the exclude patterns don't get changed at all.
      Since:
        Ant 1.6.3

    - #### setSelectors

          public void setSelectors(FileSelector[] selectors)

      Set the selectors that will select the filelist.
      Specified by:
        `setSelectors` in interface `SelectorScanner`
      Parameters:
        `selectors` - specifies the selectors to be invoked on a scan.

    - #### isEverythingIncluded

          public boolean isEverythingIncluded()

      Return whether or not the scanner has included all the files or directories it has come across so far.
      Returns:
        `true` if all files and directories which have been found so far have been included.

    - #### scan

          public void scan()
                    throws java.lang.IllegalStateException

      Scan for files which match at least one include pattern and don't match any exclude patterns. If there are selectors then the files must pass muster there, as well. Scans under basedir, if set; otherwise the include patterns without leading wildcards specify the absolute paths of the files that may be included.
      Specified by:
        `scan` in interface `FileScanner`
      Throws:
        `java.lang.IllegalStateException` - if the base directory was set incorrectly (i.e. if it doesn't exist or isn't a directory).

    - #### clearResults

          protected void clearResults()

      Clear the result caches for a scan.

    - #### slowScan

          protected void slowScan()

      Top level invocation for a slow scan. A slow scan builds up a full list of excluded/included files/directories, whereas a fast scan will only have full results for included files, as it ignores directories which can't possibly hold any included files/directories.

      Returns immediately if a slow scan has already been completed.

    - #### scandir

          protected void scandir(java.io.File dir,
                                 java.lang.String vpath,
                                 boolean fast)

      Scan the given directory for files and directories. Found files and directories are placed in their respective collections, based on the matching of includes, excludes, and the selectors. When a directory is found, it is scanned recursively.
      Parameters:
        `dir` - The directory to scan. Must not be `null`.
        `vpath` - The path relative to the base directory (needed to prevent problems with an absolute path when using dir). Must not be `null`.
        `fast` - Whether or not this call is part of a fast scan.
      See Also:
        `filesIncluded`, `filesNotIncluded`, `filesExcluded`, `dirsIncluded`, `dirsNotIncluded`, `dirsExcluded`, `slowScan()`

    - #### isIncluded

          protected boolean isIncluded(java.lang.String name)

      Test whether or not a name matches against at least one include pattern.
      Parameters:
        `name` - The path to match. Must not be `null`.
      Returns:
        `true` when the name matches against at least one include pattern, or `false` otherwise.

    - #### couldHoldIncluded

          protected boolean couldHoldIncluded(java.lang.String name)

      Test whether or not a name matches the start of at least one include pattern.
      Parameters:
        `name` - The name to match. Must not be `null`.
      Returns:
        `true` when the name matches against the start of at least one include pattern, or `false` otherwise.

    - #### isExcluded

          protected boolean isExcluded(java.lang.String name)

      Test whether or not a name matches against at least one exclude pattern.
      Parameters:
        `name` - The name to match. Must not be `null`.
      Returns:
        `true` when the name matches against at least one exclude pattern, or `false` otherwise.

    - #### isSelected

          protected boolean isSelected(java.lang.String name,
                                       java.io.File file)

      Test whether a file should be selected.
      Parameters:
        `name` - the filename to check for selecting.
        `file` - the java.io.File object for this filename.
      Returns:
        `false` when the selectors says that the file should not be selected, `true` otherwise.

    - #### getIncludedFiles

          public java.lang.String[] getIncludedFiles()

      Return the names of the files which matched at least one of the include patterns and none of the exclude patterns. The names are relative to the base directory.
      Specified by:
        `getIncludedFiles` in interface `FileScanner`
      Returns:
        the names of the files which matched at least one of the include patterns and none of the exclude patterns.

    - #### getIncludedFilesCount

          public int getIncludedFilesCount()

      Return the count of included files.
      Returns:
        `int`.
      Since:
        Ant 1.6.3

    - #### getNotIncludedFiles

          public java.lang.String[] getNotIncludedFiles()

      Return the names of the files which matched none of the include patterns. The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.
      Specified by:
        `getNotIncludedFiles` in interface `FileScanner`
      Returns:
        the names of the files which matched none of the include patterns.
      See Also:
        `slowScan()`

    - #### getExcludedFiles

          public java.lang.String[] getExcludedFiles()

      Return the names of the files which matched at least one of the include patterns and at least one of the exclude patterns. The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.
      Specified by:
        `getExcludedFiles` in interface `FileScanner`
      Returns:
        the names of the files which matched at least one of the include patterns and at least one of the exclude patterns.
      See Also:
        `slowScan()`

    - #### getDeselectedFiles

          public java.lang.String[] getDeselectedFiles()

      Return the names of the files which were selected out and therefore not ultimately included.

      The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.

      Specified by:
        `getDeselectedFiles` in interface `SelectorScanner`
      Returns:
        the names of the files which were deselected.
      See Also:
        `slowScan()`

    - #### getIncludedDirectories

          public java.lang.String[] getIncludedDirectories()

      Return the names of the directories which matched at least one of the include patterns and none of the exclude patterns. The names are relative to the base directory.
      Specified by:
        `getIncludedDirectories` in interface `FileScanner`
      Returns:
        the names of the directories which matched at least one of the include patterns and none of the exclude patterns.

    - #### getIncludedDirsCount

          public int getIncludedDirsCount()

      Return the count of included directories.
      Returns:
        `int`.
      Since:
        Ant 1.6.3

    - #### getNotIncludedDirectories

          public java.lang.String[] getNotIncludedDirectories()

      Return the names of the directories which matched none of the include patterns. The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.
      Specified by:
        `getNotIncludedDirectories` in interface `FileScanner`
      Returns:
        the names of the directories which matched none of the include patterns.
      See Also:
        `slowScan()`

    - #### getExcludedDirectories

          public java.lang.String[] getExcludedDirectories()

      Return the names of the directories which matched at least one of the include patterns and at least one of the exclude patterns. The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.
      Specified by:
        `getExcludedDirectories` in interface `FileScanner`
      Returns:
        the names of the directories which matched at least one of the include patterns and at least one of the exclude patterns.
      See Also:
        `slowScan()`

    - #### getDeselectedDirectories

          public java.lang.String[] getDeselectedDirectories()

      Return the names of the directories which were selected out and therefore not ultimately included.

      The names are relative to the base directory. This involves performing a slow scan if one has not already been completed.

      Specified by:
        `getDeselectedDirectories` in interface `SelectorScanner`
      Returns:
        the names of the directories which were deselected.
      See Also:
        `slowScan()`

    - #### getNotFollowedSymlinks

          public java.lang.String[] getNotFollowedSymlinks()

      Absolute paths of all symbolic links that haven't been followed but would have been followed had followsymlinks been true or maxLevelsOfSymlinks been bigger.
      Returns:
        sorted array of not followed symlinks
      Since:
        Ant 1.8.0
      See Also:
        `notFollowedSymlinks`

    - #### addDefaultExcludes

          public void addDefaultExcludes()

      Add default exclusions to the current exclusions set.
      Specified by:
        `addDefaultExcludes` in interface `FileScanner`

    - #### getResource

          public Resource getResource(java.lang.String name)

      Get the named resource.
      Specified by:
        `getResource` in interface `ResourceFactory`
      Parameters:
        `name` - path name of the file relative to the dir attribute.
      Returns:
        the resource with the given name.
      Since:
        Ant 1.5.2